package de.humance.eco.profile.model.impl;

import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.impl.BaseModelImpl;
import com.liferay.portal.service.ServiceContext;

import com.liferay.portlet.expando.model.ExpandoBridge;
import com.liferay.portlet.expando.util.ExpandoBridgeFactoryUtil;

import de.humance.eco.profile.model.QualificationType;
import de.humance.eco.profile.model.QualificationTypeModel;

import java.io.Serializable;

import java.sql.Types;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * The base model implementation for the QualificationType service. Represents a row in the &quot;Profile_QualificationType&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface {@link de.humance.eco.profile.model.QualificationTypeModel} exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link QualificationTypeImpl}.
 * </p>
 *
 * @author Humance
 * @see QualificationTypeImpl
 * @see de.humance.eco.profile.model.QualificationType
 * @see de.humance.eco.profile.model.QualificationTypeModel
 * @generated
 */
public class QualificationTypeModelImpl extends BaseModelImpl<QualificationType>
    implements QualificationTypeModel {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. All methods that expect a qualification type model instance should use the {@link de.humance.eco.profile.model.QualificationType} interface instead.
     */
    public static final String TABLE_NAME = "Profile_QualificationType";
    public static final Object[][] TABLE_COLUMNS = {
            { "qualificationTypeId", Types.BIGINT },
            { "creatorId", Types.BIGINT },
            { "creatorName", Types.VARCHAR },
            { "createDate", Types.TIMESTAMP },
            { "modifierId", Types.BIGINT },
            { "modifierName", Types.VARCHAR },
            { "modifiedDate", Types.TIMESTAMP },
            { "name", Types.VARCHAR },
            { "description", Types.VARCHAR },
            { "note", Types.VARCHAR },
            { "iconId", Types.BIGINT }
        };
    public static final String TABLE_SQL_CREATE = "create table Profile_QualificationType (qualificationTypeId LONG not null primary key,creatorId LONG,creatorName VARCHAR(255) null,createDate DATE null,modifierId LONG,modifierName VARCHAR(255) null,modifiedDate DATE null,name VARCHAR(1000) null,description TEXT null,note VARCHAR(2000) null,iconId LONG)";
    public static final String TABLE_SQL_DROP = "drop table Profile_QualificationType";
    public static final String ORDER_BY_JPQL = " ORDER BY qualificationType.name ASC";
    public static final String ORDER_BY_SQL = " ORDER BY Profile_QualificationType.name ASC";
    public static final String DATA_SOURCE = "liferayDataSource";
    public static final String SESSION_FACTORY = "liferaySessionFactory";
    public static final String TX_MANAGER = "liferayTransactionManager";
    public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.entity.cache.enabled.de.humance.eco.profile.model.QualificationType"),
            true);
    public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.finder.cache.enabled.de.humance.eco.profile.model.QualificationType"),
            true);
    public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(com.liferay.util.service.ServiceProps.get(
                "value.object.column.bitmask.enabled.de.humance.eco.profile.model.QualificationType"),
            true);
    public static long NAME_COLUMN_BITMASK = 1L;
    public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(com.liferay.util.service.ServiceProps.get(
                "lock.expiration.time.de.humance.eco.profile.model.QualificationType"));
    private static ClassLoader _classLoader = QualificationType.class.getClassLoader();
    private static Class<?>[] _escapedModelInterfaces = new Class[] {
            QualificationType.class
        };
    private long _qualificationTypeId;
    private long _creatorId;
    private String _creatorName;
    private Date _createDate;
    private long _modifierId;
    private String _modifierName;
    private Date _modifiedDate;
    private String _name;
    private String _originalName;
    private String _description;
    private String _note;
    private long _iconId;
    private long _columnBitmask;
    private QualificationType _escapedModel;

    public QualificationTypeModelImpl() {
    }

    @Override
    public long getPrimaryKey() {
        return _qualificationTypeId;
    }

    @Override
    public void setPrimaryKey(long primaryKey) {
        setQualificationTypeId(primaryKey);
    }

    @Override
    public Serializable getPrimaryKeyObj() {
        return _qualificationTypeId;
    }

    @Override
    public void setPrimaryKeyObj(Serializable primaryKeyObj) {
        setPrimaryKey(((Long) primaryKeyObj).longValue());
    }

    @Override
    public Class<?> getModelClass() {
        return QualificationType.class;
    }

    @Override
    public String getModelClassName() {
        return QualificationType.class.getName();
    }

    @Override
    public Map<String, Object> getModelAttributes() {
        Map<String, Object> attributes = new HashMap<String, Object>();

        attributes.put("qualificationTypeId", getQualificationTypeId());
        attributes.put("creatorId", getCreatorId());
        attributes.put("creatorName", getCreatorName());
        attributes.put("createDate", getCreateDate());
        attributes.put("modifierId", getModifierId());
        attributes.put("modifierName", getModifierName());
        attributes.put("modifiedDate", getModifiedDate());
        attributes.put("name", getName());
        attributes.put("description", getDescription());
        attributes.put("note", getNote());
        attributes.put("iconId", getIconId());

        return attributes;
    }

    @Override
    public void setModelAttributes(Map<String, Object> attributes) {
        Long qualificationTypeId = (Long) attributes.get("qualificationTypeId");

        if (qualificationTypeId != null) {
            setQualificationTypeId(qualificationTypeId);
        }

        Long creatorId = (Long) attributes.get("creatorId");

        if (creatorId != null) {
            setCreatorId(creatorId);
        }

        String creatorName = (String) attributes.get("creatorName");

        if (creatorName != null) {
            setCreatorName(creatorName);
        }

        Date createDate = (Date) attributes.get("createDate");

        if (createDate != null) {
            setCreateDate(createDate);
        }

        Long modifierId = (Long) attributes.get("modifierId");

        if (modifierId != null) {
            setModifierId(modifierId);
        }

        String modifierName = (String) attributes.get("modifierName");

        if (modifierName != null) {
            setModifierName(modifierName);
        }

        Date modifiedDate = (Date) attributes.get("modifiedDate");

        if (modifiedDate != null) {
            setModifiedDate(modifiedDate);
        }

        String name = (String) attributes.get("name");

        if (name != null) {
            setName(name);
        }

        String description = (String) attributes.get("description");

        if (description != null) {
            setDescription(description);
        }

        String note = (String) attributes.get("note");

        if (note != null) {
            setNote(note);
        }

        Long iconId = (Long) attributes.get("iconId");

        if (iconId != null) {
            setIconId(iconId);
        }
    }

    @Override
    public long getQualificationTypeId() {
        return _qualificationTypeId;
    }

    @Override
    public void setQualificationTypeId(long qualificationTypeId) {
        _qualificationTypeId = qualificationTypeId;
    }

    @Override
    public long getCreatorId() {
        return _creatorId;
    }

    @Override
    public void setCreatorId(long creatorId) {
        _creatorId = creatorId;
    }

    @Override
    public String getCreatorName() {
        if (_creatorName == null) {
            return StringPool.BLANK;
        } else {
            return _creatorName;
        }
    }

    @Override
    public void setCreatorName(String creatorName) {
        _creatorName = creatorName;
    }

    @Override
    public Date getCreateDate() {
        return _createDate;
    }

    @Override
    public void setCreateDate(Date createDate) {
        _createDate = createDate;
    }

    @Override
    public long getModifierId() {
        return _modifierId;
    }

    @Override
    public void setModifierId(long modifierId) {
        _modifierId = modifierId;
    }

    @Override
    public String getModifierName() {
        if (_modifierName == null) {
            return StringPool.BLANK;
        } else {
            return _modifierName;
        }
    }

    @Override
    public void setModifierName(String modifierName) {
        _modifierName = modifierName;
    }

    @Override
    public Date getModifiedDate() {
        return _modifiedDate;
    }

    @Override
    public void setModifiedDate(Date modifiedDate) {
        _modifiedDate = modifiedDate;
    }

    @Override
    public String getName() {
        if (_name == null) {
            return StringPool.BLANK;
        } else {
            return _name;
        }
    }

    @Override
    public void setName(String name) {
        _columnBitmask = -1L;

        if (_originalName == null) {
            _originalName = _name;
        }

        _name = name;
    }

    public String getOriginalName() {
        return GetterUtil.getString(_originalName);
    }

    @Override
    public String getDescription() {
        if (_description == null) {
            return StringPool.BLANK;
        } else {
            return _description;
        }
    }

    @Override
    public void setDescription(String description) {
        _description = description;
    }

    @Override
    public String getNote() {
        if (_note == null) {
            return StringPool.BLANK;
        } else {
            return _note;
        }
    }

    @Override
    public void setNote(String note) {
        _note = note;
    }

    @Override
    public long getIconId() {
        return _iconId;
    }

    @Override
    public void setIconId(long iconId) {
        _iconId = iconId;
    }

    public long getColumnBitmask() {
        return _columnBitmask;
    }

    @Override
    public ExpandoBridge getExpandoBridge() {
        return ExpandoBridgeFactoryUtil.getExpandoBridge(0,
            QualificationType.class.getName(), getPrimaryKey());
    }

    @Override
    public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
        ExpandoBridge expandoBridge = getExpandoBridge();

        expandoBridge.setAttributes(serviceContext);
    }

    @Override
    public QualificationType toEscapedModel() {
        if (_escapedModel == null) {
            _escapedModel = (QualificationType) ProxyUtil.newProxyInstance(_classLoader,
                    _escapedModelInterfaces, new AutoEscapeBeanHandler(this));
        }

        return _escapedModel;
    }

    @Override
    public Object clone() {
        QualificationTypeImpl qualificationTypeImpl = new QualificationTypeImpl();

        qualificationTypeImpl.setQualificationTypeId(getQualificationTypeId());
        qualificationTypeImpl.setCreatorId(getCreatorId());
        qualificationTypeImpl.setCreatorName(getCreatorName());
        qualificationTypeImpl.setCreateDate(getCreateDate());
        qualificationTypeImpl.setModifierId(getModifierId());
        qualificationTypeImpl.setModifierName(getModifierName());
        qualificationTypeImpl.setModifiedDate(getModifiedDate());
        qualificationTypeImpl.setName(getName());
        qualificationTypeImpl.setDescription(getDescription());
        qualificationTypeImpl.setNote(getNote());
        qualificationTypeImpl.setIconId(getIconId());

        qualificationTypeImpl.resetOriginalValues();

        return qualificationTypeImpl;
    }

    @Override
    public int compareTo(QualificationType qualificationType) {
        int value = 0;

        value = getName().compareToIgnoreCase(qualificationType.getName());

        if (value != 0) {
            return value;
        }

        return 0;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }

        if (!(obj instanceof QualificationType)) {
            return false;
        }

        QualificationType qualificationType = (QualificationType) obj;

        long primaryKey = qualificationType.getPrimaryKey();

        if (getPrimaryKey() == primaryKey) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public int hashCode() {
        return (int) getPrimaryKey();
    }

    @Override
    public void resetOriginalValues() {
        QualificationTypeModelImpl qualificationTypeModelImpl = this;

        qualificationTypeModelImpl._originalName = qualificationTypeModelImpl._name;

        qualificationTypeModelImpl._columnBitmask = 0;
    }

    @Override
    public CacheModel<QualificationType> toCacheModel() {
        QualificationTypeCacheModel qualificationTypeCacheModel = new QualificationTypeCacheModel();

        qualificationTypeCacheModel.qualificationTypeId = getQualificationTypeId();

        qualificationTypeCacheModel.creatorId = getCreatorId();

        qualificationTypeCacheModel.creatorName = getCreatorName();

        String creatorName = qualificationTypeCacheModel.creatorName;

        if ((creatorName != null) && (creatorName.length() == 0)) {
            qualificationTypeCacheModel.creatorName = null;
        }

        Date createDate = getCreateDate();

        if (createDate != null) {
            qualificationTypeCacheModel.createDate = createDate.getTime();
        } else {
            qualificationTypeCacheModel.createDate = Long.MIN_VALUE;
        }

        qualificationTypeCacheModel.modifierId = getModifierId();

        qualificationTypeCacheModel.modifierName = getModifierName();

        String modifierName = qualificationTypeCacheModel.modifierName;

        if ((modifierName != null) && (modifierName.length() == 0)) {
            qualificationTypeCacheModel.modifierName = null;
        }

        Date modifiedDate = getModifiedDate();

        if (modifiedDate != null) {
            qualificationTypeCacheModel.modifiedDate = modifiedDate.getTime();
        } else {
            qualificationTypeCacheModel.modifiedDate = Long.MIN_VALUE;
        }

        qualificationTypeCacheModel.name = getName();

        String name = qualificationTypeCacheModel.name;

        if ((name != null) && (name.length() == 0)) {
            qualificationTypeCacheModel.name = null;
        }

        qualificationTypeCacheModel.description = getDescription();

        String description = qualificationTypeCacheModel.description;

        if ((description != null) && (description.length() == 0)) {
            qualificationTypeCacheModel.description = null;
        }

        qualificationTypeCacheModel.note = getNote();

        String note = qualificationTypeCacheModel.note;

        if ((note != null) && (note.length() == 0)) {
            qualificationTypeCacheModel.note = null;
        }

        qualificationTypeCacheModel.iconId = getIconId();

        return qualificationTypeCacheModel;
    }

    @Override
    public String toString() {
        StringBundler sb = new StringBundler(23);

        sb.append("{qualificationTypeId=");
        sb.append(getQualificationTypeId());
        sb.append(", creatorId=");
        sb.append(getCreatorId());
        sb.append(", creatorName=");
        sb.append(getCreatorName());
        sb.append(", createDate=");
        sb.append(getCreateDate());
        sb.append(", modifierId=");
        sb.append(getModifierId());
        sb.append(", modifierName=");
        sb.append(getModifierName());
        sb.append(", modifiedDate=");
        sb.append(getModifiedDate());
        sb.append(", name=");
        sb.append(getName());
        sb.append(", description=");
        sb.append(getDescription());
        sb.append(", note=");
        sb.append(getNote());
        sb.append(", iconId=");
        sb.append(getIconId());
        sb.append("}");

        return sb.toString();
    }

    @Override
    public String toXmlString() {
        StringBundler sb = new StringBundler(37);

        sb.append("<model><model-name>");
        sb.append("de.humance.eco.profile.model.QualificationType");
        sb.append("</model-name>");

        sb.append(
            "<column><column-name>qualificationTypeId</column-name><column-value><![CDATA[");
        sb.append(getQualificationTypeId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorId</column-name><column-value><![CDATA[");
        sb.append(getCreatorId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>creatorName</column-name><column-value><![CDATA[");
        sb.append(getCreatorName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>createDate</column-name><column-value><![CDATA[");
        sb.append(getCreateDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierId</column-name><column-value><![CDATA[");
        sb.append(getModifierId());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifierName</column-name><column-value><![CDATA[");
        sb.append(getModifierName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>modifiedDate</column-name><column-value><![CDATA[");
        sb.append(getModifiedDate());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>name</column-name><column-value><![CDATA[");
        sb.append(getName());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>description</column-name><column-value><![CDATA[");
        sb.append(getDescription());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>note</column-name><column-value><![CDATA[");
        sb.append(getNote());
        sb.append("]]></column-value></column>");
        sb.append(
            "<column><column-name>iconId</column-name><column-value><![CDATA[");
        sb.append(getIconId());
        sb.append("]]></column-value></column>");

        sb.append("</model>");

        return sb.toString();
    }
}
